/*===========================================
			Wii Paint 1.0
	Exemple d'utilisation des librairies
	GRRlib 2.0 par Kontakatilu
					traducteur : graph05
===========================================*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include <ogcsys.h>
#include <gccore.h>
#include "wiiuse.h"

// On inclus les archives d'images prcdemments converties avec GRRLIB GFX Converter
#include "../gfx/letras.h" // texte du dbut, un peu moche pour dire vrai
#include "../gfx/fondo.h"
#include "../gfx/mano.h"


#include "GRRLIB.h"
extern u16 *GRRLIB_buffer;
extern u16 *GRRLIB_bufferdos;
#define MAX_WIIMOTES				4
unsigned int irx=0,iry=0; //Variables des coordonnes des infrarouges
unsigned int buttonB=0; // Le bouton B
unsigned int buttonA=0; // Le bouton A
int i;

void (*reload)() = (void (*) ()) 0x80001800; //Fonction pour rinitialiser le Loader
// On surveille les vnements lis aux bontons de la wiimote
void wiimote_event(struct wiimote_t* wm, int event) {
	
	switch (event) {
		case WIIUSE_EVENT:
		
			buttonB=0; //Variables  zro
			//buttonA=0;// Variables  zro
			
			//if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_ONE)){
			//wiiuse_set_ir(wm, 1);
			//usleep(200000);
			//wiiuse_motion_sensing(wm, 0);
			//usleep(200000);
			//}
			
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_B)) // Assigne 1  la variable du bouton B quand on l'appuie
				buttonB=1;
			if (IS_RELEASED(wm, WIIMOTE_BUTTON_A)) // Quand on lche le bouton A la variable change  0
				buttonA=0;
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_A)) //Assigne 1  la variable du bouton A
				buttonA=1;
			// Sert  la synchronisation de la wiimote
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_UP)) // Flche Haut
				wiiuse_set_ir(wm, 1);
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_DOWN)) // Flche Bas
				wiiuse_set_ir(wm, 0);
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_LEFT)) // Flche Gauche
				wiiuse_motion_sensing(wm, 0);
			if (IS_JUST_PRESSED(wm, WIIMOTE_BUTTON_RIGHT)) // Flche Droite
				wiiuse_motion_sensing(wm, 1);
					irx=(unsigned)wm->ir.dot[0].x;
					iry=(unsigned)wm->ir.dot[0].y;
					
			break;
	}
}

//Module principal
int main() {
u16 colore; // Variable o l'on stocke la couleur du pinceau
colore=0x2bf; // Donnons une valeur [par dfaut]  la couleur, le bleu
// Dclarons les coordonnes initiales
int xold;
int yold;
// Donnons-leur une valeur symbolique pour que le compilateur ne plante pas
xold=0;
yold=0;
    wiimote** wiimotes;
// Dmarre la vido
	GRRLIB_buffer=(u16 *)malloc(640*480*2);	
	GRRLIB_bufferdos=(u16 *)malloc(640*480*2);
	VIDEO_Init();
	PAD_Init(); // Dmarre les contrles je crois...

	GRRLIB_InitVideo();
	GRRLIB_Start();
// Efface l'cran et attend la synchronisation avec la wiimote
	GRRLIB_FillScreen(0x0000); // Remplis l'cran en noir
	
// Prsente le message de synchronisation de la wiimote, trs simple maintenant que j'ai chang la lettre jeje [???]
	/* === Messages originaux ===
	GRRLIB_Print(15,50+35*3,32,32,"     PORFAVOR",letras_img);
	GRRLIB_Print(15,50+35*4,32,32,"    PULSA 1 Y 2",letras_img);
	GRRLIB_Print(15,50+35*5,32,32,"   EN TU WIIMOTE",letras_img);
	========================== */
	GRRLIB_Print(15,50+35*3,32,32,"     VEUILLEZ",letras_img);
	GRRLIB_Print(15,50+35*4,32,32,"    PRESSER 1 ET 2",letras_img);
	GRRLIB_Print(15,50+35*5,32,32,"   SUR VOTRE WIIMOTE",letras_img);
	GRRLIB_Render();
	VIDEO_WaitVSync();

	*((u32*)0xcd0000c0) |= 0x100;
	// C'est ce qui doit synchroniser la wiimote
	bte_init();
	bte_start();
	wiimotes =  wiiuse_init(MAX_WIIMOTES, wiimote_event);
	wiiuse_find(wiimotes, MAX_WIIMOTES, 5);
	wiiuse_connect(wiimotes, MAX_WIIMOTES);
	wiiuse_set_leds(wiimotes[0], WIIMOTE_LED_1); // Allume la led 1
	wiiuse_rumble(wiimotes[0], 1); // Allume le moteur de vibrations
	usleep(200000); // Fait une pause de 200ms 
	wiiuse_rumble(wiimotes[0], 0); //Eteint le moteur de vibrations
	wiiuse_set_ir(wiimotes[0], 0);
	usleep(200000); // Fait une pause de 200ms 
	wiiuse_motion_sensing(wiimotes[0], 1);
	GRRLIB_FillScreen(0x0000); // Remplis l'cran principal de noir
	GRRLIB_FillScreendos(0x0000); // Remplis l'cran de fond en noir
	GRRLIB_DrawImgdos(0,0,fondo_width,fondo_high,fondo_img,0,1); // Dessine le fond du programme sur l'cran du bas
	
	while(1){ // Se rpte jusqu' la fin du programme
		GRRLIB_FillScreen(0x0000); // Remplis l'cran principal de noir
		int ex;for(ex=0;ex<640*480;ex++) GRRLIB_buffer[ex]=GRRLIB_bufferdos[ex]; // Copie le buffer de l'cran de fond sur le principal
  		GRRLIB_DrawImg(irx-13,iry,mano_width,mano_high,mano_img,0,1);// Dessine notre propre main [le curseur]
		if(buttonB==1) reload (); // Si on appuie sur le bouton B, le loader se rinitialise
		if(buttonA==1){ // Si on appuie sur A, a dessine
			if(irx-1>83){ // Vrifie si nous somme sur la palette de couleurs [palette  gauche de l'cran] 
				/*C'est l'ancienne routine que j'avais avant pour peindre, mais cela peignait seulement des points et si tu bougeais trs rapidement, tu les dispersais seulement et ils ne changeaient pas pour la ligne d'aprs
				GRRLIB_PutPixeldos(irx-1,iry-1,color);GRRLIB_PutPixeldos(irx-1,iry,color);	GRRLIB_PutPixeldos(irx-1,iry+1,color);
				GRRLIB_PutPixeldos(irx,iry-1,color);GRRLIB_PutPixeldos(irx,iry,color);	GRRLIB_PutPixeldos(irx,iry+1,color);
				GRRLIB_PutPixeldos(irx+1,iry-1,color);GRRLIB_PutPixeldos(irx+1,iry,color);GRRLIB_PutPixeldos(irx+1,iry+1,color);
				*/
				GRRLIB_Linedos(xold,yold,irx,iry,colore); // Dessine une ligne entre l'ancien point et le nouveau
			} else { // Si nous sommes sur la palette, on rcupre la couleur
				colore=GRRLIB_bufferdos[iry*640+(irx)]; // On assigne la couleur de l'cran de fond au pinceau
			}
		}
		xold=irx;yold=iry; // On stocke les coordonnes actuelles pour la ligne suivente
		GRRLIB_Render();
		VIDEO_WaitVSync();
	}
return(0);
}
